#include <stdio.h>
#include <stdlib.h>
/********************************************************************
When you get the atis, you are given two important pieces of information:
  * The runway in use.
  * The bearing of surface winds.
  *  It's useful to be able to quickly work out, in your head, which way the
     wind will be, relative to the runway, when you take off or land.
  *  This program drills the user with randomly generated runways and
     winds.
    Copyright 1996, Jerome Kaidor
*********************************************************************/
#define WIND_FROM_RIGHT 1
#define WIND_FROM_LEFT 0
#define HEADWIND  2
#define TAILWIND 3
main()
	{
	int i;
	printf( "**************\n");
	printf( "* atis-drill *\n" );
	printf( "**************\n");
	while( 1 )
		{
		one_atis_drill();
		}
	}
	
one_atis_drill()
	{
	int runway_designator;
	int runway_magnetic_heading;
	int wind_magnetic_bearing;
	int wind_angle_guess;
	int wind_angle;
	char wind_side_string[ 10 ];
	char wind_side_guess[ 10 ];
	char wind_side;

	/***********************************************************
	Wind magnetic bearing as given in ATIS always seems to be an
	integral multiple of 10....
	************************************************************/
	wind_magnetic_bearing = ( random_angle()/10 ) * 10;
	runway_magnetic_heading = ( random_angle()/10 ) * 10;

	/***************************************************************
	For now, we'll allow side winds, front winds, but not tail winds.
	We'll assume that they'd have changed the runway otherwise
	****************************************************************/
	if( abs( angular_difference( runway_magnetic_heading, wind_magnetic_bearing )) > 90 )
		{
		wind_magnetic_bearing += 180;
		wind_magnetic_bearing = normalize_angle( wind_magnetic_bearing );
		}
	runway_designator = runway_magnetic_heading / 10;

	wind_angle = abs( angular_difference( runway_magnetic_heading, wind_magnetic_bearing ));
	if( angular_difference( runway_magnetic_heading, wind_magnetic_bearing ) > 0 )
		{
		wind_side = 'L';
		strcpy( wind_side_string, "left" );
		}
	else if( angular_difference( runway_magnetic_heading, wind_magnetic_bearing ) < 0 )
		{
		wind_side = 'R';
		strcpy( wind_side_string, "right" );
		}
	else
		{
		wind_side = 'H';                         /* for HEADwind */
		strcpy( wind_side_string, "front" );
		}

	printf( "Wind is %d degrees, Runway %d in use\n", wind_magnetic_bearing, runway_designator );
	printf( "What side is the wind from( L(eft), R(ight), H(ead), or T(ail) )?" );
	scanf( "%1s", wind_side_guess );
	if( toupper( wind_side_guess[0] ) == wind_side )
		{
		printf( "Ok, What angle in degrees is the wind from?" );
		scanf( "%d", &wind_angle_guess );
		if(wind_angle_guess == wind_angle )
			{
			printf( "Correct!\n" );
			}
		else
			{
			/*******************************************
			User got the side right, but the angle wrong.
			********************************************/
			printf( "Sorry, The wind angle is %d degrees from the %s\n", wind_angle, wind_side_string );
			}
		}
	else
		{
		/*****************************
		User got the wind side wrong! 
		******************************/
		printf( "Nope, the wind was from the %s\n",  wind_side_string );
		}
	}
	
int random_angle()
	{
	return random_number( 360 );
	}	
	
int random_number( int range )
	{
	int i,j,done;
	/************************************
	We have a small range we'd like to produce random numbers for.
	Unfortunately, rand() only gives numbers for a very large range.
	****************************************/
	
	i = RAND_MAX / range;   /* how much bigger than range is RAND_MAX? */
	done = 0;
	while( !done )
		{
		j = rand()/i;
		if( j <= range ) done = 1;
		}
	return j;
	}
	
int opposite_angle( int input_angle )	
	{
	int o_param;
	o_param = input_angle + 180;
	while( o_param > 360 ) o_param -= 360;
	return o_param;
	}

/**************************************************
angular difference:
   result is postive if angle_1 > angle_2
   result is negative if angle_1 < angle_2
***************************************************/
int angular_difference( int angle_1, int angle_2 )
	{
	int o_param;
	angle_1 = normalize_angle( angle_1 );
	angle_2 = normalize_angle( angle_2 );
	o_param = angle_1 - angle_2;
	return o_param;
	}

int normalize_angle( input_angle )
	{
	while( input_angle > 360 ) input_angle -= 360;
	return input_angle;
	}
